Module javafx.base
Package javafx.beans.property

# Class SetPropertyBase<E>

java.lang.Object
javafx.beans.binding.SetExpression<E>
javafx.beans.property.ReadOnlySetProperty<E>
javafx.beans.property.SetProperty<E>
javafx.beans.property.SetPropertyBase<E>

Type Parameters:
  `E` - the type of the `Set` elements

All Implemented Interfaces:
  `Iterable<E>`, `Collection<E>`, `Set<E>`, `Observable`, `Property<ObservableSet<E>>`, `ReadOnlyProperty<ObservableSet<E>>`, `ObservableObjectValue<ObservableSet<E>>`, `ObservableSetValue<E>`, `ObservableValue<ObservableSet<E>>`, `WritableObjectValue<ObservableSet<E>>`, `WritableSetValue<E>`, `WritableValue<ObservableSet<E>>`, `ObservableSet<E>`

Direct Known Subclasses:
  `SimpleSetProperty`

public abstract class SetPropertyBase<E> extends SetProperty<E>
The class `SetPropertyBase` is the base class for a property wrapping an `ObservableSet`. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.

Since:
  JavaFX 2.1
See Also:
  - `ObservableSet`
  - `SetProperty`

## Property Summary

Properties
Type
Property
Description
`ReadOnlyBooleanProperty`
`empty`
A boolean property that is `true`, if the set is empty.
`ReadOnlyIntegerProperty`
`size`
An integer property that represents the size of the set.

## Constructor Summary

Constructors
Constructor
Description
`SetPropertyBase()`
The Constructor of `SetPropertyBase`
`SetPropertyBase(ObservableSet<E> initialValue)`
The constructor of the `SetPropertyBase`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addListener(InvalidationListener listener)`
Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
`void`
`addListener(ChangeListener<? super ObservableSet<E>> listener)`
Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
`void`
`addListener(SetChangeListener<? super E> listener)`
Add a listener to this observable set.
`void`
`bind(ObservableValue<? extends ObservableSet<E>> newObservable)`
Create a unidirection binding for this `Property`.
`ReadOnlyBooleanProperty`
`emptyProperty()`
A boolean property that is `true`, if the set is empty.
`protected void`
`fireValueChangedEvent()`
Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`.
`protected void`
`fireValueChangedEvent(SetChangeListener.Change<? extends E> change)`
Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`.
`ObservableSet<E>`
`get()`
Get the wrapped value.
`protected void`
`invalidated()`
The method `invalidated()` can be overridden to receive invalidation notifications.
`boolean`
`isBound()`
Can be used to check, if a `Property` is bound.
`void`
`removeListener(InvalidationListener listener)`
Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
`void`
`removeListener(ChangeListener<? super ObservableSet<E>> listener)`
Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
`void`
`removeListener(SetChangeListener<? super E> listener)`
Tries to removed a listener from this observable set.
`void`
`set(ObservableSet<E> newValue)`
Set the wrapped value.
`ReadOnlyIntegerProperty`
`sizeProperty()`
An integer property that represents the size of the set.
`String`
`toString()`
Returns a string representation of this `SetPropertyBase` object.
`void`
`unbind()`
Remove the unidirectional binding for this `Property`.

### Methods inherited from class javafx.beans.property.SetProperty

`bindBidirectional, setValue, unbindBidirectional`

### Methods inherited from class javafx.beans.property.ReadOnlySetProperty

`bindContent, bindContentBidirectional, equals, hashCode, unbindContent, unbindContentBidirectional`

### Methods inherited from class javafx.beans.binding.SetExpression

`add, addAll, asString, clear, contains, containsAll, getSize, getValue, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, remove, removeAll, retainAll, setExpression, size, toArray, toArray`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream, toArray`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Methods inherited from interface javafx.beans.value.ObservableValue

`getValue`

### Methods inherited from interface javafx.beans.property.ReadOnlyProperty

`getBean, getName`

### Methods inherited from interface java.util.Set

`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, spliterator, toArray, toArray`

### Methods inherited from interface javafx.beans.value.WritableValue

`getValue`

## Property Details

### size

public ReadOnlyIntegerProperty sizeProperty

Specified by:
  `sizeProperty` in class `SetExpression<E>`
Returns:
  the property
See Also:
  - `sizeProperty()`

### empty

public ReadOnlyBooleanProperty emptyProperty

Specified by:
  `emptyProperty` in class `SetExpression<E>`
Returns:
  the `ReadOnlyBooleanProperty`
See Also:
  - `emptyProperty()`

## Constructor Details

### SetPropertyBase

public SetPropertyBase()
The Constructor of `SetPropertyBase`

### SetPropertyBase

public SetPropertyBase(ObservableSet<E> initialValue)
The constructor of the `SetPropertyBase`.

Parameters:
  `initialValue` - the initial value of the wrapped value

## Method Details

### sizeProperty

public ReadOnlyIntegerProperty sizeProperty()
Description copied from class: `SetExpression`
An integer property that represents the size of the set.

Specified by:
  `sizeProperty` in class `SetExpression<E>`
Returns:
  the `size` property
See Also:
  - `SetExpression.getSize()`

### emptyProperty

public ReadOnlyBooleanProperty emptyProperty()
Description copied from class: `SetExpression`
A boolean property that is `true`, if the set is empty.

Specified by:
  `emptyProperty` in class `SetExpression<E>`
Returns:
  the `empty` property
See Also:
  - `SetExpression.isEmpty()`

### addListener

public void addListener(InvalidationListener listener)
Description copied from interface: `Observable`
Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

Parameters:
  `listener` - The listener to register
See Also:
  - `Observable.removeListener(InvalidationListener)`

### removeListener

public void removeListener(InvalidationListener listener)
Description copied from interface: `Observable`
Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

Parameters:
  `listener` - The listener to remove
See Also:
  - `Observable.addListener(InvalidationListener)`

### addListener

public void addListener(ChangeListener<? super ObservableSet<E>> listener)
Description copied from interface: `ObservableValue`
Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

Parameters:
  `listener` - The listener to register
See Also:
  - `ObservableValue.removeListener(ChangeListener)`

### removeListener

public void removeListener(ChangeListener<? super ObservableSet<E>> listener)
Description copied from interface: `ObservableValue`
Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

Parameters:
  `listener` - The listener to remove
See Also:
  - `ObservableValue.addListener(ChangeListener)`

### addListener

public void addListener(SetChangeListener<? super E> listener)
Description copied from interface: `ObservableSet`
Add a listener to this observable set.

Parameters:
  `listener` - the listener for listening to the set changes

### removeListener

public void removeListener(SetChangeListener<? super E> listener)
Description copied from interface: `ObservableSet`
Tries to removed a listener from this observable set. If the listener is not attached to this list, nothing happens.

Parameters:
  `listener` - a listener to remove

### fireValueChangedEvent

protected void fireValueChangedEvent()
Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`. This method is called when the value is changed, either manually by calling `set(javafx.collections.ObservableSet)` or in case of a bound property, if the binding becomes invalid.

### fireValueChangedEvent

protected void fireValueChangedEvent(SetChangeListener.Change<? extends E> change)
Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`. This method is called when the content of the list changes.

Parameters:
  `change` - the change that needs to be propagated

### invalidated

protected void invalidated()
The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

### get

public ObservableSet<E> get()
Description copied from interface: `WritableObjectValue`
Get the wrapped value. This must be identical to the value returned from `WritableValue.getValue()`.

This method exists only to align WritableObjectValue API with `WritableBooleanValue` and subclasses of `WritableNumberValue`

Returns:
  The current value

### set

public void set(ObservableSet<E> newValue)
Description copied from interface: `WritableObjectValue`
Set the wrapped value. Should be equivalent to `WritableValue.setValue(java.lang.Object)`

Parameters:
  `newValue` - The new value
See Also:
  - `WritableObjectValue.get()`

### isBound

public boolean isBound()
Description copied from interface: `Property`
Can be used to check, if a `Property` is bound.

Returns:
  `true` if the `Property` is bound, `false` otherwise
See Also:
  - `Property.bind(javafx.beans.value.ObservableValue)`

### bind

public void bind(ObservableValue<? extends ObservableSet<E>> newObservable)
Description copied from interface: `Property`
Create a unidirection binding for this `Property`.

Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

Parameters:
  `newObservable` - The observable this `Property` should be bound to.

### unbind

public void unbind()
Description copied from interface: `Property`
Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.

See Also:
  - `Property.bind(javafx.beans.value.ObservableValue)`

### toString

public String toString()
Returns a string representation of this `SetPropertyBase` object.

Overrides:
  `toString` in class `SetProperty<E>`
Returns:
  a string representation of this `SetPropertyBase` object.